
!ClassDescription methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 10/14/2011 15:28'!
compileSilently: code 
	"Compile the code and classify the resulting method in the given category, leaving no trail in the system log, nor in any change set, nor in the 'recent submissions' list. This should only be used when you know for sure that the compilation will succeed."

	^ self compileSilently: code classified: 'not defined category' notifying: nil.! !

!ClassDescription methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 10/14/2011 15:20'!
instVarIndexFor: instVarName
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
		ifTrue: [0]
		ifFalse: [instanceVariables indexOf: instVarName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [superclass instVarIndexFor: instVarName]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!FLMethodContextSerializationTest methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MMP 1/10/2012 20:44'!
testMethodContextWithClosureContextWithOutPointerTesting
	"This test should be improved"
	| methodContext1  materializedMethodContext1  |
	methodContext1 := self class blockClosureContextWithOutPointerTesting.
	"I don't know this fails in Pharo 1.1.1'"
	"self assert: (methodContext1 tempNamed: 'string') = 'test'. "
	materializedMethodContext1 := self resultOfSerializeAndMaterialize: methodContext1.
	"I don't know this fails in Pharo 1.1.1'"
	"self assert: (materializedMethodContext1 tempNamed: 'string') = 'test'. "
	methodContext1 assertWellMaterializedInto: materializedMethodContext1 in: self.
	
! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 5/26/2012 00:27'!
defaultSuperclass
	^ Object! !

!Class methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 1/10/2012 22:43'!
addClassVarNamed: aString 
	"Add the argument, aString, as a class variable of the receiver.
	Signal an error if the first character of aString is not capitalized,
	or if it is already a variable named in the class."
	| symbol oldState |
	oldState := self copy.
	aString first canBeGlobalVarInitial
		ifFalse: [^self error: aString, ' class variable name should be capitalized; proceed to include anyway.'].
	symbol := aString asSymbol.
	self withAllSubclasses do: 
		[:subclass | 
		(subclass bindingOf: symbol) ifNotNil:[
			^ self error: aString 
				, ' is already used as a variable name in class ' 
				, subclass name]].
	classPool == nil ifTrue: [classPool := Dictionary new].
	(classPool includesKey: symbol) ifFalse: 
		["Pick up any refs in Undeclared"
		classPool declare: symbol from: Undeclared.
		SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: oldState to: self]! !

!Class methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 10/22/2011 20:50'!
addInstVarNamed: aString
	"Add the argument, aString, as one of the receiver's instance variables."
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString, ' ', aString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category
! !

!Class methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 10/22/2011 20:48'!
removeInstVarNamed: aString 
	"Remove the argument, aString, as one of the receiver's instance variables."

	| newInstVarString |
	(self instVarNames includes: aString)
		ifFalse: [self error: aString , ' is not one of my instance variables'].
	newInstVarString := ''.
	(self instVarNames copyWithout: aString) do: 
		[:varName | newInstVarString := newInstVarString , ' ' , varName].
	^(ClassBuilder new)
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: newInstVarString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!Metaclass methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 10/22/2011 20:49'!
addInstVarNamed: aString 
	"Add the argument, aString, as one of the receiver's instance variables."

	| fullString |
	fullString := String streamContents: [:strm |
		self instVarNames do: [:aString2 | strm nextPutAll: aString2; space].
		strm nextPutAll: aString].
	self instanceVariableNames: fullString! !

!Metaclass methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 10/22/2011 20:47'!
removeInstVarNamed: aString 
	"Remove the argument, aString, as one of the receiver's instance variables."

	| newArray newString |
	(self instVarNames includes: aString)
		ifFalse: [self error: aString , ' is not one of my instance variables'].
	newArray := self instVarNames copyWithout: aString.
	newString := ''.
	newArray do: [:aString2 | newString := aString2 , ' ' , newString].
	self instanceVariableNames: newString! !

!Collection methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 10/14/2011 15:15'!
sum: aSymbolOrBlock 
	 
	^self 
		inject: 0 
		into: [:sum :each | sum + (aSymbolOrBlock value: each)]! !

!SmalltalkImage methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 5/26/2012 00:41'!
shortImageName
	"Answer the current image name but only that name and not the full path as with imageName."
	"SmalltalkImage current shortImageName"

	^ FileDirectory baseNameFor: (FileDirectory default localNameFor: Smalltalk imageName).! !

!FLWeakObjectsTest methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 1/10/2012 22:32'!
expectedFailures

	^ #( testAssociationWithWeakFinalizationList )! !

!SequenceableCollection methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MartinDias 10/14/2011 15:13'!
reduceRight: aBlock
	"Fold the result of the receiver from right to left into aBlock. The argument aBlock must take two or more arguments."

	"#(1 2 3) reduceRight: [ :a :b | a - b ].
		--> (1 - (2 - 3)) = 2
	#(1 + 3 - 5) reduceRight: [ :a :op :b | a perform: op with: b ].
		--> (1 + (3 - 5)) = -1"

	| arguments |
	self emptyCheck.
	arguments := Array new: aBlock argumentCount.
	(arguments size = 0 or: [ (self size + 1) \\ (arguments size - 1) > 0 ])
		ifTrue: [ self error: 'Collection size and block argument count do not match.' ].
	arguments at: arguments size put: self last.
	self size - arguments size + 1 to: 1 by: 1 - arguments size do: [ :index |
		arguments
			replaceFrom: 1 to: aBlock argumentCount - 1 with: self startingAt: index;
			at: arguments size put: (aBlock valueWithArguments: arguments) ].
	^ arguments last! !

!SequenceableCollection methodsFor: '*FuelCompatibilityBeforePharo12' stamp: 'MarianoMartinezPeck 1/10/2012 21:12'!
shuffleBy: aRandom
	"Durstenfeld's version of the Fisher-Yates shuffle"

	self size to: 2 by: -1 do: [ :i | 
		self swap: i with: (aRandom nextInt: i) ]! !
